#include "HelloWorldScene.h"

CCScene* HelloWorld::scene()
{
	CCScene *scene = CCScene::node();
	HelloWorld *layer = HelloWorld::node();
	scene->addChild(layer);
	return scene;
}

/*	ʱġ ϴ Լ	*/
bool HelloWorld::init()
{
	if ( !CCLayer::init() )
		return false;

	m_pMissile = new CCSprite;
	m_pMissile->initWithFile("missile.png");
	m_pMissile->setPosition(ccp(30,30));
	this->addChild(m_pMissile);

	m_fSpeed = 4;							//	̻ ̵ ӵ
	m_Vector = ccp(0, 0);					//	̻ ̵  
	m_fFirePower = 300;                     //	ʱ ӵ ʱġ 
	v_0 = ccp(m_fFirePower, m_fFirePower);	//	ʱ ӵ

	m_fGravity = 400;						//	߷
	m_fAngle = 55;							//	ϴ (Degree)
	m_fRadian = m_fAngle *  3.14f / 180.f;	//	ϴ (Radian)
	m_fAirResist = 75;                      //	 

	this->schedule(schedule_selector(HelloWorld::Tick));

	return true;
}

/*	ֱ ȣǴ Լ	*/
void HelloWorld::Tick(float dt)
{
	this->SetVector(dt);	//	̻ ̵   
	
	this->Action(dt);		//	̻ 
}

/*	̻ ̵  ͸ ϴ Լ	*/
void HelloWorld::SetVector(float dt)
{
	//	̻ ̵  ͸ Ѵ.
	m_Vector.x = cos(m_fRadian) * v_0.x * m_fSpeed;
	m_Vector.y = sin(m_fRadian) * v_0.y * m_fSpeed;
	
	/*
		 x  ְ, ߷ y  ִ.
	*/
	v_0.x -= m_fAirResist * dt;
	v_0.y -= m_fGravity * dt; 
	
	/*
		̵  (ʹ ũ  ´.) x ũ⸦ Ѵ.
		̵   x  , ü   Ѵٰ ϸ
		̵   x  Ǹ,  ̵Ѵٴ ǹ̴.
		, ̻ ư ִµ, ǳ  з  ȿ   ִ.
		⼭ ǳ ȿ  ٴ    . 
	*/
	if( m_Vector.x < 10 )
		m_Vector.x = 10;
}

/*	̻ ̵ ȸ ϴ Լ	*/
void HelloWorld::Action(float dt)
{
	CCPoint pos = m_pMissile->getPosition();

	pos.x += m_Vector.x * dt;
	pos.y += m_Vector.y * dt;
	
	//	̻ ϴٰ(ưٰ)   
	if( pos.y < 0 )
	{
		pos = ccp(30,30);						//	ʱ ġ 缳
		v_0 = ccp(m_fFirePower, m_fFirePower);	//	ʱ ӵ 缳
	}
	m_pMissile->setPosition(pos);
	
	//	̻ ȸ
	float radian = atan2(m_Vector.x, m_Vector.y);
	float Angle = radian * 180.f / 3.14f;

	m_pMissile->setRotation(Angle);
}

